#ifndef INDEXER_H
#define INDEXER_H

#include <QtGui>


namespace Ui {
    class MainWindow;
}



struct File{
    QString name;
    qint64 size;
};

struct Folder{
    QString name;
    qint64 size;
    qint64 filesSize;
    qint64 foldersSize;
    qint64 items;
    QList<File> files;
    QList<Folder> folders;
};




typedef QList<Folder> Folders;
typedef QList<File> Files;




class Indexer : public QThread
{
    Q_OBJECT
public:
    explicit Indexer(QObject *parent = 0);
    void run();

    void calculateFolderSize(Folder *folder);
    void indexDir(QString dir);

    Folder parseDir(QString dir);
    Folder getFolder(QString id);

    Folder idx_folder;
    QString directory;

    qint64 totalFiles;
    qint64 totalFolders;

signals:

public slots:


};

#endif // INDEXER_H
